<template>
  <div class="hello">
    <h1>{{ msg }}</h1>
    with {{inputData}} from App.vue
  </div>
  <input type="number" :value="inputData.counter" @input="updateCounter">
  <input type="text" :value="inputData.user" @input="updateUser">
</template>

<script>
export default {
  name: 'Component1',
  props: {
    msg: String,
    inputData: Object
  },
  setup(props,context){


    const component1Data = {
      // local Data storage. stores only diff to original
    }

    const updateCounter = function(e){
      component1Data.counter = e.target.value;
      sendUpdateToParent(component1Data);
    }
    const updateUser = function(e){
      component1Data.user = e.target.value;
      sendUpdateToParent(component1Data);
    }
    let sendUpdateToParent = function(obj){
      
      console.log(context);
      
      context.emit("updateData",obj)
    }

    return {
      component1Data,
      updateCounter,
      updateUser
    }
  },
  emits:[
    "updateData"
  ]
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
